Index: /trunk/Cocoa/Pester/Source/PSMovieAlertController.h
===================================================================
--- /trunk/Cocoa/Pester/Source/PSMovieAlertController.h	(revision 52)
+++ /trunk/Cocoa/Pester/Source/PSMovieAlertController.h	(revision 53)
@@ -13,4 +13,6 @@
 
 @interface PSMovieAlertController : NSWindowController {
+    PSAlarm *alarm;
+    PSMovieAlert *alert;
     IBOutlet NSMovieView *movieView;
     void *theMovie; /* Movie */
@@ -19,7 +21,7 @@
 }
 
-+ (PSMovieAlertController *)controllerWithAlarm:(PSAlarm *)alarm movieAlert:(PSMovieAlert *)alert;
++ (PSMovieAlertController *)controllerWithAlarm:(PSAlarm *)anAlarm movieAlert:(PSMovieAlert *)anAlert;
 
-- (id)initWithAlarm:(PSAlarm *)alarm movieAlert:(PSMovieAlert *)alert;
+- (id)initWithAlarm:(PSAlarm *)anAlarm movieAlert:(PSMovieAlert *)anAlert;
 
 @end
Index: /trunk/Cocoa/Pester/Source/PSMovieAlertController.m
===================================================================
--- /trunk/Cocoa/Pester/Source/PSMovieAlertController.m	(revision 52)
+++ /trunk/Cocoa/Pester/Source/PSMovieAlertController.m	(revision 53)
@@ -17,7 +17,7 @@
 @implementation PSMovieAlertController
 
-+ (PSMovieAlertController *)controllerWithAlarm:(PSAlarm *)alarm movieAlert:(PSMovieAlert *)alert;
++ (PSMovieAlertController *)controllerWithAlarm:(PSAlarm *)anAlarm movieAlert:(PSMovieAlert *)anAlert;
 {
-    return [[self alloc] initWithAlarm: alarm movieAlert: alert];
+    return [[self alloc] initWithAlarm: anAlarm movieAlert: anAlert];
 }
 
@@ -39,9 +39,11 @@
 }
 
-- (id)initWithAlarm:(PSAlarm *)alarm movieAlert:(PSMovieAlert *)alert;
+- (id)initWithAlarm:(PSAlarm *)anAlarm movieAlert:(PSMovieAlert *)anAlert;
 {
     if ([self initWithWindowNibName: @"Movie alert"]) {
-        NSMovie *movie = [alert movie];
+        NSMovie *movie = [anAlert movie];
         NSWindow *window = [self window]; // connect outlets
+        alarm = anAlarm;
+        alert = anAlert;
         [movieView setMovie: movie];
         theMovie = [movie QTMovie];
@@ -67,4 +69,13 @@
             [window setFrame: frame display: NO];
             [window setTitle: [alarm message]];
+            {	// XXX workaround for (IMO) ugly appearance of Cocoa utility windows
+                NSView *miniButton = [window standardWindowButton: NSWindowMiniaturizeButton],
+                *zoomButton = [window standardWindowButton: NSWindowZoomButton];
+                // NOTE: this will not work if the window is resizable: when the frame is reset, the standard buttons reappear
+                [miniButton setFrameOrigin: NSMakePoint(-100, -100)];
+                [zoomButton setFrameOrigin: NSMakePoint(-100, -100)];
+                [[miniButton superview] setNeedsDisplay: YES];
+                [[zoomButton superview] setNeedsDisplay: YES];
+            }
             [[self window] orderFrontRegardless];
         }
@@ -91,5 +102,6 @@
     repetitions = 0;
     [movieView stop: self];
-    [self release];
+    [alert completedForAlarm: alarm];
+    [self autorelease];
     // note: there may still be a retained copy of this object until the runloop timer has let go of us at the end of the current movie playback cycle; donÕt worry about it.
 }
Index: /trunk/Cocoa/Pester/Source/PSNotifierAlert.m
===================================================================
--- /trunk/Cocoa/Pester/Source/PSNotifierAlert.m	(revision 52)
+++ /trunk/Cocoa/Pester/Source/PSNotifierAlert.m	(revision 53)
@@ -26,3 +26,21 @@
 }
 
+- (BOOL)requiresPesterFrontmost;
+{
+    return YES;
+}
+
+- (NSAttributedString *)actionDescription;
+{
+    return [@"Display message and time" small];
+}
+
+#pragma mark property list serialization (Pester 1.1)
+
+- (id)initWithPropertyList:(NSDictionary *)dict;
+{
+    [self release];
+    return [[PSNotifierAlert alert] retain];
+}
+
 @end
Index: /trunk/Cocoa/Pester/Source/PSPowerManager.h
===================================================================
--- /trunk/Cocoa/Pester/Source/PSPowerManager.h	(revision 53)
+++ /trunk/Cocoa/Pester/Source/PSPowerManager.h	(revision 53)
@@ -0,0 +1,33 @@
+//
+//  PSPowerManager.h
+//  Pester
+//
+//  Created by Nicholas Riley on Mon Dec 23 2002.
+//  Copyright (c) 2002 Nicholas Riley. All rights reserved.
+//
+
+#import <Foundation/Foundation.h>
+#import <IOKit/IOKitLib.h>
+
+@interface PSPowerManager : NSObject {
+    id delegate;
+    io_connect_t root_port;
+    io_object_t notifier;
+}
+
+- (id)initWithDelegate:(id)aDelegate;
+
++ (BOOL)autoWakeSupported;
++ (NSDate *)wakeTime;
++ (void)setWakeTime:(NSDate *)time;
++ (void)clearWakeTime;
+
+@end
+
+@interface NSObject (PSPowerManagerDelegate)
+
+- (void)powerManagerWillSleep:(PSPowerManager *)powerManager;
+- (BOOL)powerManagerShouldSleep:(PSPowerManager *)powerManager;
+- (void)powerManagerDidWake:(PSPowerManager *)powerManager;
+
+@end
Index: /trunk/Cocoa/Pester/Source/PSPowerManager.m
===================================================================
--- /trunk/Cocoa/Pester/Source/PSPowerManager.m	(revision 53)
+++ /trunk/Cocoa/Pester/Source/PSPowerManager.m	(revision 53)
@@ -0,0 +1,270 @@
+//
+//  PSPowerManager.m
+//  Pester
+//
+//  Created by Nicholas Riley on Mon Dec 23 2002.
+//  Copyright (c) 2002 Nicholas Riley. All rights reserved.
+//
+
+#import "PSPowerManager.h"
+
+#import <IOKit/pwr_mgt/IOPMLib.h>
+#import <IOKit/IOMessage.h>
+#import <CoreFoundation/CoreFoundation.h>
+
+/*
+ * Copyright (c) 2002 Apple Computer, Inc. All rights reserved.
+ *
+ * @APPLE_LICENSE_HEADER_START@
+ *
+ * The contents of this file constitute Original Code as defined in and
+ * are subject to the Apple Public Source License Version 1.1 (the
+ * "License").  You may not use this file except in compliance with the
+ * License.  Please obtain a copy of the License at
+ * http://www.apple.com/publicsource and read it before using this file.
+ *
+ * This Original Code and all software distributed under the License are
+ * distributed on an "AS IS" basis, WITHOUT WARRANTY OF ANY KIND, EITHER
+ * EXPRESS OR IMPLIED, AND APPLE HEREBY DISCLAIMS ALL SUCH WARRANTIES,
+ * INCLUDING WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE OR NON-INFRINGEMENT.  Please see the
+ * License for the specific language governing rights and limitations
+ * under the License.
+ *
+ * @APPLE_LICENSE_HEADER_END@
+ */
+
+/* Sample code to set an automatic wakeup timer to wake machines from sleep.
+
+When a machine is asleep, most hardware (including the processor) is
+powered off. The PMU chip is one of the few things left powered on, and it's
+able to generate a wakeup event on a timer.
+This code shows how to set the wakeup timer within the PMU.
+*/
+
+// From autowake.cpp:
+
+// #define kAppleVIAUserClientMagicCookie 0x101face // or 0x101beef -- for PMU
+// #define kAppleVIAUserClientMagicCookie 0x101beef // or 0x101face  -- for PMU
+
+// The difference is 101beef is only for superusers and 101face works for
+// non-privileged users.  I have not determined which calls are only available
+// for superusers
+
+#define PMU_MAGIC_PASSWORD	0x0101FACE // BEEF
+
+/* ==========================================
+* Close a device user client
+* =========================================== */
+static kern_return_t
+closeDevice(io_connect_t con)
+{
+    kern_return_t ret = IOServiceClose(con);
+
+    NSCAssert1(ret == kIOReturnSuccess, @"closeDevice: IOServiceClose returned an error of type %08lx", (unsigned long)ret);
+
+    return ret;
+}
+
+/* ==========================================
+* Open an IORegistry device user client
+* =========================================== */
+static void
+openDevice(io_object_t obj, unsigned int type, io_connect_t * con)
+{
+    kern_return_t ret = IOServiceOpen(obj, mach_task_self(), type, con);
+
+    NSCAssert1(ret == kIOReturnSuccess, @"openDevice: IOServiceOpen returned an error of type %08lx", (unsigned long)ret);
+}
+
+/* ===========================================
+* Changes the string for a registry
+* property.
+* ===========================================  */
+void
+writeDataProperty(io_object_t handle, CFStringRef name,
+                  unsigned char * bytes, unsigned int size)
+{
+    kern_return_t kr = kIOReturnNoMemory;
+    CFDataRef data;
+    CFMutableDictionaryRef dict = 0;
+
+    data = CFDataCreate(kCFAllocatorDefault, bytes, size);
+    NSCAssert(data != NULL, @"writeDataProperty: CFDataCreate failed");
+    [(NSData *)data autorelease];
+
+    dict = CFDictionaryCreateMutable(kCFAllocatorDefault, 1, &kCFTypeDictionaryKeyCallBacks, &kCFTypeDictionaryValueCallBacks);
+    NSCAssert(data != NULL, @"writeDataProperty: CFDictionaryCreateMutable failed");
+    [(NSMutableDictionary *)dict autorelease];
+
+    CFDictionarySetValue(dict, name, data);
+    kr = IOConnectSetCFProperties(handle, dict);
+    NSCAssert1(kr == KERN_SUCCESS, @"writeDataProperty: IOConnectSetCFProperties returned an error of type %08lx", (unsigned long)kr);
+}
+
+/* ==========================================
+* Write a data property to the PMU driver
+* Arguments
+*     pmuReference - the IORegistry device to write to
+*     propertyName - Name of the property to write to
+*     data - Data to write
+*     dataSize - Data size
+* =========================================== */
+void
+writePMUProperty(io_object_t pmuReference, CFStringRef propertyName, void *data, size_t dataSize)
+{
+    io_connect_t conObj;
+    openDevice(pmuReference, PMU_MAGIC_PASSWORD, &conObj);
+    writeDataProperty(conObj, propertyName, (unsigned char *)data, dataSize);
+    closeDevice(conObj);
+}
+
+
+/* ==========================================
+* Look through the registry and search for an
+* IONetworkInterface objects with the given
+* name.
+* If a match is found, the object is returned.
+* =========================================== */
+
+io_service_t
+getInterfaceWithName(mach_port_t masterPort, char *className)
+{
+    io_service_t obj;
+
+    obj = IOServiceGetMatchingService(masterPort, IOServiceMatching(className));
+
+    NSCAssert(obj != NULL, @"getInterfaceWithName: IOServiceGetMatchingService returned NULL");
+
+    return obj;
+}
+
+/* ==========================================
+* Find the PMU in the IORegistry
+* =========================================== */
+io_service_t
+openPMUComPort(void)
+{
+    static mach_port_t masterPort;
+    kern_return_t kr;
+
+    // Get a master port to talk with the mach_kernel
+    kr = IOMasterPort(bootstrap_port, &masterPort);
+    NSCAssert1(kr == KERN_SUCCESS, @"openPMUComPort: IOMasterPort returned an error of type %08lx", (unsigned long)kr);
+
+    return getInterfaceWithName(masterPort, "ApplePMU");
+}
+
+
+/* ==========================================
+* Release our reference to the PMU in the IORegistry
+* =========================================== */
+void
+closePMUComPort(io_object_t pmuRef)
+{
+    IOObjectRelease(pmuRef);
+}
+
+@implementation PSPowerManager
+
++ (BOOL)autoWakeSupported;
+{
+    io_service_t pmuReference = openPMUComPort();
+    if (pmuReference == NULL) return NO;
+    closePMUComPort(pmuReference);
+    return YES;
+}
+
++ (NSDate *)wakeTime;
+{
+    io_service_t pmuReference = openPMUComPort();
+    NSNumber *autoWakeTime;
+    unsigned long long rawWakeTime;
+    
+    NSAssert(pmuReference != NULL, @"Couldn’t find PMU in IORegistry. This computer may not support automatic wake from sleep.");
+    autoWakeTime = (NSNumber *)IORegistryEntryCreateCFProperty(pmuReference, CFSTR("AutoWake"), NULL, 0);
+    closePMUComPort(pmuReference);
+
+    if (autoWakeTime == nil) return nil;
+    rawWakeTime = [autoWakeTime unsignedLongLongValue];
+    if (rawWakeTime == 0) return nil;
+    // XXX no idea what the epoch is supposed to be, but this works...
+    return [NSDate dateWithTimeIntervalSinceReferenceDate: rawWakeTime - 18446744072475718320LLU];
+}
+
++ (void)setWakeTime:(NSDate *)time;
+{
+    unsigned long wakeTime;
+    io_service_t pmuReference = openPMUComPort();
+    NSAssert(pmuReference != NULL, @"Couldn’t find PMU in IORegistry. This computer may not support automatic wake from sleep.");
+
+    if (time == nil) wakeTime = 0;
+    else {
+        wakeTime = [time timeIntervalSinceNow];
+        if (wakeTime == 0) wakeTime++; // 0 will disable
+    }
+    writePMUProperty(pmuReference, CFSTR("AutoWake"), (unsigned long *)&wakeTime, sizeof(wakeTime));
+    
+    closePMUComPort(pmuReference);
+}
+
++ (void)clearWakeTime;
+{
+    [self setWakeTime: nil];
+}
+
+// modified from RegisterForSleep sample code
+
+- (void)_messageReceived:(natural_t)messageType withArgument:(void *)messageArgument;
+{
+    switch (messageType) {
+        case kIOMessageSystemWillSleep:
+            if ([delegate respondsToSelector: @selector(powerManagerWillSleep:)])
+                [delegate powerManagerWillSleep: self];
+            IOAllowPowerChange(root_port, (long)messageArgument);
+            break;
+        case kIOMessageCanSystemSleep:
+            if ([delegate respondsToSelector: @selector(powerManagerShouldSleep:)]) {
+                if ([delegate powerManagerShouldSleep: self]) {
+                    IOAllowPowerChange(root_port, (long)messageArgument);
+                } else {
+                    IOCancelPowerChange(root_port, (long)messageArgument);
+                }
+            }
+            break;
+        case kIOMessageSystemHasPoweredOn:
+            if ([delegate respondsToSelector: @selector(powerManagerDidWake:)])
+                [delegate powerManagerDidWake: self];
+            break;
+    }
+}
+
+void
+powerCallback(void *refCon, io_service_t service, natural_t messageType, void *messageArgument)
+{
+    [(PSPowerManager *)refCon _messageReceived: messageType withArgument: messageArgument];
+}
+
+- (id)initWithDelegate:(id)aDelegate;
+{
+    if ( (self = [super init]) != nil) {
+        IONotificationPortRef notificationPort;
+
+        delegate = [aDelegate retain];
+
+        root_port = IORegisterForSystemPower(self, &notificationPort, powerCallback, &notifier);
+        NSAssert(root_port != NULL, @"IORegisterForSystemPower failed");
+
+        CFRunLoopAddSource(CFRunLoopGetCurrent(), IONotificationPortGetRunLoopSource(notificationPort), kCFRunLoopDefaultMode);
+    }
+    return self;
+}
+
+- (void)dealloc;
+{
+    IODeregisterForSystemPower(&notifier);
+    [delegate release];
+    [super dealloc];
+}
+
+@end
Index: /trunk/Cocoa/Pester/Source/PSPropertyListSerialization.h
===================================================================
--- /trunk/Cocoa/Pester/Source/PSPropertyListSerialization.h	(revision 53)
+++ /trunk/Cocoa/Pester/Source/PSPropertyListSerialization.h	(revision 53)
@@ -0,0 +1,19 @@
+//
+//  PSPropertyListSerialization.h
+//  Pester
+//
+//  Created by Nicholas Riley on Sat Dec 21 2002.
+//  Copyright (c) 2002 Nicholas Riley. All rights reserved.
+//
+
+#import <Foundation/Foundation.h>
+
+
+@protocol PSPropertyListSerialization
+
+// 1.1 only, deprecated when we move to keyed archiving
+- (NSDictionary *)propertyListRepresentation;
+// subclasses should NOT call [super initWithPropertyList:] - infinite recursion will result!
+- (id)initWithPropertyList:(NSDictionary *)dict;
+
+@end
Index: /trunk/Cocoa/Pester/Source/PSScriptAlert.h
===================================================================
--- /trunk/Cocoa/Pester/Source/PSScriptAlert.h	(revision 52)
+++ /trunk/Cocoa/Pester/Source/PSScriptAlert.h	(revision 53)
@@ -18,3 +18,5 @@
 - (id)initWithScriptFileAlias:(BDAlias *)anAlias;
 
+- (BDAlias *)scriptFileAlias;
+
 @end
Index: /trunk/Cocoa/Pester/Source/PSScriptAlert.m
===================================================================
--- /trunk/Cocoa/Pester/Source/PSScriptAlert.m	(revision 52)
+++ /trunk/Cocoa/Pester/Source/PSScriptAlert.m	(revision 53)
@@ -9,5 +9,9 @@
 #import "PSScriptAlert.h"
 #import "BDAlias.h"
-#import "NDAppleScriptObject.h"
+// XXX remove #import "NDAppleScriptObject.h"
+#import "NSDictionary-NJRExtensions.h"
+
+// property list keys
+static NSString * const PLAlertAlias = @"alias"; // NSData
 
 @implementation PSScriptAlert
@@ -26,11 +30,71 @@
 }
 
+- (BDAlias *)scriptFileAlias;
+{
+    return alias;
+}
+
 - (void)triggerForAlarm:(PSAlarm *)alarm;
 {
-    NDAppleScriptObject *as = [NDAppleScriptObject appleScriptObjectWithContentsOfFile: [alias fullPath]];
+    NSString *scriptPath = [alias fullPath];
 
-    if (as != nil) {
-        [as execute];
+    if (scriptPath == nil) {
+        NSRunAlertPanel(@"CanÕt find script", @"Pester couldnÕt find the script for the alarm Ò%@Ó.",
+                        nil, nil, nil, [alarm message]);
+    } else {
+        NSDictionary *errorInfo;
+        NSAppleScript *script = [[NSAppleScript alloc] initWithContentsOfURL: [NSURL fileURLWithPath: scriptPath] error: &errorInfo];
+        if (script == nil) {
+            NSString *errorMessage = [errorInfo objectForKey: NSAppleScriptErrorMessage];
+            NSNumber *errorNumber = [errorInfo objectForKey: NSAppleScriptErrorNumber];
+            NSString *appName = [errorInfo objectForKey: NSAppleScriptErrorAppName];
+            if (errorMessage == nil) errorMessage = [errorInfo objectForKey: NSAppleScriptErrorBriefMessage];
+            NSRunAlertPanel(@"Script loading error",
+                            @"Pester encountered an error while attempting to load Ò%@Ó%@ %@",
+                            nil, nil, nil,
+                            [[NSFileManager defaultManager] displayNameAtPath: scriptPath],
+                            errorMessage == nil ? @"" : [NSString stringWithFormat: @":\n\n%@%@", appName == nil ? @"" : @"Ò%@Ó reported an error: ", errorMessage],
+                            errorNumber == nil ? @"" : [NSString stringWithFormat: @"(%@)", errorNumber]);
+        } else {
+            NSAppleEventDescriptor *scriptResult = [script executeAndReturnError: &errorInfo];
+            if (scriptResult == nil) {
+                NSString *errorMessage = [errorInfo objectForKey: NSAppleScriptErrorMessage];
+                NSNumber *errorNumber = [errorInfo objectForKey: NSAppleScriptErrorNumber];
+                NSString *appName = [errorInfo objectForKey: NSAppleScriptErrorAppName];
+                if (errorMessage == nil) errorMessage = [errorInfo objectForKey: NSAppleScriptErrorBriefMessage];
+                NSRunAlertPanel(@"Script execution error",
+                                @"Pester encountered an error while attempting to execute the script Ò%@Ó%@ %@",
+                                nil, nil, nil,
+                                [[NSFileManager defaultManager] displayNameAtPath: scriptPath],
+                                errorMessage == nil ? @"" : [NSString stringWithFormat: @":\n\n%@%@", appName == nil ? @"" : @"Ò%@Ó reported an error: ", errorMessage],
+                                errorNumber == nil ? @"" : [NSString stringWithFormat: @"(%@)", errorNumber]);
+            }
+        }
     }
+    [self completedForAlarm: alarm];
 }
+
+- (NSAttributedString *)actionDescription;
+{
+    NSMutableAttributedString *string = [[@"Do script " small] mutableCopy];
+    NSString *scriptName = [alias displayNameWithKindString: NULL];
+    if (scriptName == nil) scriptName = @"ÇcanÕt locate scriptÈ";
+    [string appendAttributedString: [scriptName underlined]];
+    return [string autorelease];
+}
+
+#pragma mark property list serialization (Pester 1.1)
+
+- (NSDictionary *)propertyListRepresentation;
+{
+    NSMutableDictionary *plAlert = [[super propertyListRepresentation] mutableCopy];
+    [plAlert setObject: [alias aliasData] forKey: PLAlertAlias];
+    return [plAlert autorelease];
+}
+
+- (id)initWithPropertyList:(NSDictionary *)dict;
+{
+    return [self initWithScriptFileAlias: [BDAlias aliasWithData: [dict objectForRequiredKey: PLAlertAlias]]];
+}
+
 @end
Index: /trunk/Cocoa/Pester/Source/PSSpeechAlert.h
===================================================================
--- /trunk/Cocoa/Pester/Source/PSSpeechAlert.h	(revision 52)
+++ /trunk/Cocoa/Pester/Source/PSSpeechAlert.h	(revision 53)
@@ -8,9 +8,11 @@
 
 #import "PSAlert.h"
-#import "SUSpeaker.h"
+
+@class SUSpeaker;
 
 @interface PSSpeechAlert : PSAlert {
     SUSpeaker *speaker;
     NSString *voice;
+    PSAlarm *alarm;
 }
 
@@ -19,3 +21,5 @@
 - (id)initWithVoice:(NSString *)aVoice;
 
+- (NSString *)voice;
+
 @end
Index: /trunk/Cocoa/Pester/Source/PSSpeechAlert.m
===================================================================
--- /trunk/Cocoa/Pester/Source/PSSpeechAlert.m	(revision 52)
+++ /trunk/Cocoa/Pester/Source/PSSpeechAlert.m	(revision 53)
@@ -4,9 +4,14 @@
 //
 //  Created by Nicholas Riley on Sat Oct 26 2002.
-//  Copyright (c) 2002 __MyCompanyName__. All rights reserved.
+//  Copyright (c) 2002 Nicholas Riley. All rights reserved.
 //
 
 #import "PSSpeechAlert.h"
 #import "PSAlarmAlertController.h"
+#import "NSDictionary-NJRExtensions.h"
+#import "SUSpeaker.h"
+
+// property list keys
+static NSString * const PLAlertVoice = @"voice"; // NSString
 
 @implementation PSSpeechAlert
@@ -20,5 +25,5 @@
 {
     if ( (self = [super init]) != nil) {
-        voice = aVoice;
+        voice = [aVoice retain];
     }
     return self;
@@ -33,20 +38,47 @@
 }
 
+- (NSString *)voice;
+{
+    return voice;
+}
+
 - (void)_stopSpeaking:(NSNotification *)notification;
 {
-    [speaker stopSpeaking];
-    // don't release here, we'll still get the didFinishSpeaking: message as a delegate
+    [speaker stopSpeaking]; // triggers didFinishSpeaking:
 }
 
-- (void)triggerForAlarm:(PSAlarm *)alarm;
+- (void)triggerForAlarm:(PSAlarm *)anAlarm;
 {
     [[NSNotificationCenter defaultCenter] addObserver: self selector: @selector(_stopSpeaking:) name: PSAlarmAlertStopNotification object: nil];
     
     if ( (speaker = [[SUSpeaker alloc] init]) == nil) return;
+    alarm = anAlarm;
     [speaker setDelegate: self];
     [speaker setVoice: [[SUSpeaker voiceNames] indexOfObject: voice] + 1];
     [speaker speakText: [alarm message]];
-    
-    [self retain];
+}
+
+- (NSAttributedString *)actionDescription;
+{
+    NSMutableAttributedString *string = [[@"Speak message with voice " small] mutableCopy];
+    [string appendAttributedString: [voice underlined]];
+    return [string autorelease];
+}
+
+#pragma mark property list serialization (Pester 1.1)
+
+- (NSDictionary *)propertyListRepresentation;
+{
+    NSMutableDictionary *plAlert = [[super propertyListRepresentation] mutableCopy];
+    [plAlert setObject: voice forKey: PLAlertVoice];
+    return [plAlert autorelease];
+}
+
+- (id)initWithPropertyList:(NSDictionary *)dict;
+{
+    if ( (self = [self init]) != nil) {
+        voice = [dict objectForRequiredKey: PLAlertVoice];
+    }
+    return self;
 }
 
@@ -55,7 +87,8 @@
 @implementation PSSpeechAlert (SUSpeakerDelegate)
 
-- (void)didFinishSpeaking:(SUSpeaker*)speaker;
+- (void)didFinishSpeaking:(SUSpeaker *)aSpeaker;
 {
-    [self release];
+    [self completedForAlarm: alarm];
+    [speaker release]; speaker = nil;
 }
 
